/*
 * Author:	gxc
 * Create data:	2005-10-12 20:09
 */

#ifndef EPOLLREACTOR_H_
#define EPOLLREACTOR_H_

#include <list>
#include "BitStorm.h"

typedef struct
{
	unsigned int id;
	unsigned int interval;
	unsigned int lastShotTick;
	ITimerCallback* callback;
	bool oneShot;
	bool remove;
} TTimerInfo;

typedef std::list<TTimerInfo> TTimerList;
typedef std::list<unsigned int> TTimerIDList;

class CEpollReactor : public ISocketReactor
{
public:
	CEpollReactor();
	virtual ~CEpollReactor();
private:
	int _epollHandle;
	bool _toExit;
	unsigned int _freeTimerID;
	TTimerIDList _freeTimerIDList;
	TTimerList _timerList;
	TTimerList _timerAddList;
	struct epoll_event* _epollEvents;
private:
	void updateTimerList();	
public:	
	bool addSocket(ISocket* socket);
	void removeSocket(ISocket* socket);
	void updateMask(ISocket* socket);
	
	unsigned int addTimer(ITimerCallback* callback, unsigned int interval,  bool oneShot);
	void removeTimer(unsigned int id);
	
	bool start();
	void update();
	void stop() ;	
};

#endif /*EPOLLREACTOR_H_*/
