/*
 * Author:	gxc
 * Create data:	2005-10-22 20:09
 */
 
#ifndef LITEWINDOW_H_
#define LITEWINDOW_H_

#include <string>
#include <gtk/gtk.h>
#include "BitStorm.h"

class CLiteWindow
{
public:
	CLiteWindow();
	virtual ~CLiteWindow();
private:
	IBTTask* _task;
	GtkWidget* _window;
	GtkWidget* _taskNameLabel;
	GtkWidget* _totalSizeLabel;
	GtkWidget* _progressBar;
	GtkWidget* _timeLabel;
	GtkWidget* _downloadToLabel;
	GtkWidget* _downloadRateLabel;
	GtkWidget* _downloadedLabel;
	GtkWidget* _peersLabel;
	GtkWidget* _uploadRateLabel;
	GtkWidget* _uploadedLabel;
	GtkWidget* _shareLabel;
	GtkWidget* _aboutButton;
	GtkWidget* _pauseButton;
	GtkWidget* _exitButton;
	GtkWidget* _maxUploadButton;
	GtkWidget* _maxUploadSpin;
	GtkWidget* _maxDownloadSpin;
	GtkWidget* _cacheSizeSpin;
	
	unsigned int _startTick;
private:
	void createWindow();
	void updateGUI();	
	
	static gboolean delete_event(GtkWidget* widget, GdkEvent* event, gpointer data);
	static void destroy(GtkWidget* widget, gpointer data);
	static gboolean timerFunc(gpointer data); 
	static void exit_button_clicked_event(GtkWidget* widget, gpointer data);
	static void about_button_clicked_event(GtkWidget* widget, gpointer data);
public:
	void run(IBTTask* task);		
	
	static std::string getUserInputTorrentFilePath();
	static std::string getUserInputDestPath(const char* fileName);
	static void showMessage(const char* msg);
};

#endif /*LITEWINDOW_H_*/
