/*
 * Author:	gxc
 * Create data:	2005-12-04 16:09
 */
 
#ifndef NEWTASKWINDOW_H_
#define NEWTASKWINDOW_H_

#include <string>
#include <gtk/gtk.h>
#include "BitStorm.h"

class CNewTaskWindow
{
public:
	CNewTaskWindow();
	virtual ~CNewTaskWindow();
private:
	IBTTask* _task;
	
	GtkWidget* _dialog;
	GtkWidget* _downloadToEntry;
	GtkListStore* _store;
	GtkWidget* _view;
	GtkWidget* _selectedSizeLabel;
	GtkWidget* _encodingComboBox;
private:
	void createWindow();
	void createFileList();
	std::string getUserInputDestPath(const char* fileName);
	void updateSelectedSize();
	void updateEncoding();
	
	static void toggle_event(GtkCellRendererToggle*cell_renderer, gchar *path, gpointer user_data);
	static void select_dir_event(GtkWidget* widget, gpointer data);
	static void encoding_changed(GtkComboBox *widget, gpointer user_data);
    static void select_all_cb (GtkWidget *widget, gpointer data);
    static void unselect_all_cb (GtkWidget *widget, gpointer data);
    static void reverse_selected_cb (GtkWidget *widget, gpointer data);

public:
	bool show(IBTTask* task);
    GtkListStore *get_store (void) { return _store; }
};

#endif /*NEWTASKWINDOW_H_*/
