/*
 * Author:	gxc
 * Create data:	2005-10-15 10:09
 */

#ifndef PEERMANAGER_H_
#define PEERMANAGER_H_

#include <string>
#include "BitStorm.h"
#include "ThreadMutex.h"

class CPeerManager : 
	public IPeerManager,
	public ITimerCallback
{
public:
	CPeerManager();
	virtual ~CPeerManager();
private:
	IBTTask* _task;
	unsigned int _connectTimerID;
	unsigned int _chokeTimerID;
	
	TPeerInfoMap _unusedPeerList;
	CThreadMutex _unusedPeerListMutex;
	
	TPeerInfoMap _connectingPeerList;
	TPeerInfoMap _connectedPeerList;
	TPeerInfoMap _banedPeerList;
private:
	void checkPeerConnection();	
	void checkPeerChoke();
	void countPeersSpeed();
	bool peerInUnusedList(std::string id);
	bool peerInConnectingList(std::string id);
	bool peerInConnectedList(std::string id);
	bool peerInBanedList(std::string id);
public:	
 	void setBTTask(IBTTask* task);
	IBTTask* getBTTask();	
	
	bool start();
	void stop();
	
	void onTimer(unsigned int id);
	
	void addPeerInfoWithoutID(const char* ip, unsigned short port);
	bool addAcceptedPeer(int handle, const char* ip, unsigned short port);
	void broadcastHave(unsigned int pieceIndex);
	void cancelPieceRequest(unsigned int pieceIndex);
	unsigned int getConnectedPeerCount();
	void onDownloadComplete();
};

#endif /*PEERMANAGER_H_*/
