/*
 * Author:	gxc
 * Create data:	2005-10-22 20:09
 */
 
#ifndef PIECEREQUEST_H_
#define PIECEREQUEST_H_

#include <string>
#include <list>

typedef struct
{
	unsigned int offset;
	unsigned int length;
	bool requested;
	std::string data;
} TRequest;
typedef std::list<TRequest> TRequestList;

class CPieceRequest
{
public:
	CPieceRequest();
	virtual ~CPieceRequest();
private:
	unsigned int _pieceIndex;		
	unsigned int _pieceLength;
	TRequestList _requestList;
public:
	void alloc(unsigned int pieceIndex, unsigned int pieceLength, unsigned int maxRequestLength);
	unsigned int getPieceIndex();
	unsigned int getPieceLength();
	unsigned int getPendingCount();
	bool cancelPendingRequest(unsigned int& pieceIndex, unsigned int& offset, unsigned int& length);
	bool complete();
	std::string getPiece();
	bool getRequest(unsigned int& pieceIndex, unsigned int& offset, unsigned int& length);		
	bool addPieceData(unsigned int offset, const char* data, size_t length);
	void clearRequest();
};

#endif /*PIECEREQUEST_H_*/
