/*
 * Author:	gxcoo
 * Create date:	2006-01-06 19:03
 */

#ifndef RATEMEASURE_H_
#define RATEMEASURE_H_

#include "BitStorm.h"
#include <list>

#define MaxPriorityLevel		5

typedef struct
{
	IRateMeasureClient* client;
	bool remove;
}TRateMeasureCtx;

typedef std::list<TRateMeasureCtx> TRateMeasureClientList;

class CRateMeasure : public IRateMeasure
{
public:
	CRateMeasure();
	virtual ~CRateMeasure();
private:
	TRateMeasureClientList _clientList;
	unsigned int _upSpeed;
	unsigned int _downSpeed;
	unsigned int _lastTick;
	unsigned int _upCount;
	unsigned int _downCount;
	
	bool _writeBlocked;
	bool _readBlocked;
private:
	void resetAllPriority();
	void scheduleUpload();
	void scheduleDownload();
	void blockReadAll(bool block);
	void blockWriteAll(bool block);
public:	
	void addClient(IRateMeasureClient* client);
	void removeClient(IRateMeasureClient* client);	
	
	void update();
	
	void setUploadSpeed(unsigned int sp);
	void setDownloadSpeed(unsigned int sp);	
	unsigned int getUploadSpeed();
	unsigned int getDownloadSpeed();	
};

#endif /*RATEMEASURE_H_*/
