/*
 * Author:	gxc
 * Create data:	2005-10-12 20:09
 */
 
#ifndef SOCKET_H_
#define SOCKET_H_

#include "BitStorm.h"

class CSocket : public ISocket
{
public:
	CSocket();
	virtual ~CSocket();
private:
		ISocketReactor* _reactor;
		int _handle;
		bool _maskRead;
		bool _maskWrite;
		bool _inReactor;
private:
	void setNonBlock();		
public:	
	void setReactor(ISocketReactor* reactor);
	ISocketReactor* getReactor();
	
	void createTCPSocket();
	void createUDPSocket();
	void close();
	void attach(int fd);
	int getHandle();
	
	bool bind(const char* ip, unsigned short port);
	void listen();
	void connect(const char* ip, unsigned short port);	
	int accept(std::string& ip, unsigned short& port);
	
	void maskRead(bool mask);
	void maskWrite(bool mask);
	bool maskRead();
	bool maskWrite();	
};

#endif /*SOCKET_H_*/
