/*
 * Author:	gxc
 * Create data:	2005-10-07 20:09
 */
 
#ifndef TRACKERMANAGER_H_
#define TRACKERMANAGER_H_

#include <pthread.h>
#include <list>
#include "BitStorm.h"

typedef std::list<ITracker*> TTrackerList;

class CTrackerManager : public ITrackerManager
{
public:
	CTrackerManager();
	virtual ~CTrackerManager();
private:
	pthread_t _thrHandle;
	bool _toExit;
	IBTTask* _task;
	unsigned int _peerCount;
	unsigned int _seedCount;
	TTrackerList _trackerList;
private:
	void createTrackers();	
	void stopTrackers();	
	void destroyTrackers();
public:
	void setBTTask(IBTTask* task);
	IBTTask* getBTTask();
	
 	bool start();
	void stop();		
	int getSeedCount();
	int getPeerCount();	
	
	int svc();
};

#endif /*TRACKERMANAGER_H_*/
