/*
 * Author:	gxc
 * Create data:	2005-10-26 20:09
 */

#ifndef UDPTRACKER_H_
#define UDPTRACKER_H_

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string>
#include "BitStorm.h"
#include "Socket.h"

class CUDPTracker :
	public ITracker,
	public CSocket
{
public:
	CUDPTracker();
	virtual ~CUDPTracker();
private:
	ITrackerManager* _trackerManager;
	std::string _url;
	
	TTrackerState _state;
	std::string _stateStr;	
	
	unsigned int _completePeer;
	unsigned int _totalPeer;
	unsigned int _interval;
	unsigned int _nextUpdateTick;
	
	int _currentEvent;
	bool _startEventSend;
	bool _completeEventSend;
	
	struct sockaddr_in _serverAddr;
	unsigned int _transID;
	int64_t _connectionID;
private:
	void sendConnectPacket();	
	void sendAnnouncPacket();	
	void processPkg(unsigned int actionID, char* data, size_t len);
	int getCurrentEvent();
public:
	void setTrackerManager(ITrackerManager* trackerManager);
	bool isProtocolSupported(const char* protocolName);
	void setUrl(const char* url);
	void update();
	void stop();
	TTrackerState getState();
	const std::string& getStateStr();
	unsigned int getSeedCount();
	unsigned int getPeerCount();
	unsigned int getInterval();
	unsigned int getNextUpdateTick();	
	
	int handleRead();
	int handleWrite();
	void handleClose();		
};

#endif /*UDPTRACKER_H_*/
