/*
 * Author:	gxc
 * Create data:	2004-03-09 20:09
 */

#include "bdict.h"
#include "binteger.h"
#include "bstring.h"
#include "blist.h"

int
CBDict::parse (const char *buf, unsigned long bufLen)
{
  int result = -1;

  if (buf[0] != 'd')
    {
      return result;
    }

  unsigned long index = 1;
  int ret = 0;
  for (; index < bufLen;)
    {
      CBString strKey;

      ret = strKey.parse (&buf[index], bufLen - index - 1);
      if (ret > 0)
	{
	  index += ret;
	  if (index < bufLen)
	    {
	      CBObject *value = NULL;
	      if (isdigit (buf[index]))
		{
		  value = new CBString;
		}
	      else if (buf[index] == 'i')
		{
		  value = new CBInteger;
		}
	      else if (buf[index] == 'l')
		{
		  value = new CBList;
		}
	      else if (buf[index] == 'd')
		{
		  value = new CBDict;
		}
	      else
		{
		  break;
		}
	      ret = value->parse (&buf[index], bufLen - index);
	      if (ret > 0)
		{
		  index += ret;
		  m_value[strKey.getValue ()] = value;
		}
	      else
		{
		  delete value;
		  break;
		}
	    }
	}
      else
	{
	  break;
	}
      if (index < bufLen && buf[index] == 'e')
	{
	  result = index + 1;
	  break;
	}
    }
  if (result == -1)
    {
      clear ();
    }

  return result;
};
