/*
 * Author:	gxcoo
 * Create date:	2004-03-06 16:03
 */

#include "blist.h"
#include "binteger.h"
#include "bstring.h"
#include "bdict.h"


int
CBList::parse (const char *buf, unsigned long bufLen)
{
  int result = -1;
  if (buf[0] == 'l')
    {
      unsigned long index = 1;
      for (; index < bufLen;)
	{
	  if (buf[index] == 'i')
	    {
	      CBInteger *bint = new CBInteger;
	      int ret = bint->parse (&buf[index], bufLen - index - 1);
	      if (ret > 0)
		{
		  m_value.push_back (bint);
		  index += ret;
		}
	      else
		{
		  delete bint;
		  break;
		}
	    }
	  else if (isdigit (buf[index]))
	    {
	      CBString *bstr = new CBString;
	      int ret = bstr->parse (&buf[index], bufLen - index - 1);
	      if (ret > 0)
		{
		  m_value.push_back (bstr);
		  index += ret;
		}
	      else
		{
		  delete bstr;
		  break;
		}
	    }
	  else if (buf[index] == 'l')
	    {
	      CBList *blist = new CBList;
	      int ret = blist->parse (&buf[index], bufLen - index - 1);
	      if (ret > 0)
		{
		  m_value.push_back (blist);
		  index += ret;
		}
	      else
		{
		  delete blist;
		  break;
		}
	    }
	  else if (buf[index] == 'd')
	    {
	      CBDict *bdict = new CBDict;
	      int ret = bdict->parse (&buf[index], bufLen - index - 1);
	      if (ret > 0)
		{
		  m_value.push_back (bdict);
		  index += ret;
		}
	      else
		{
		  delete bdict;
		  break;
		}
	    }
	  else if (buf[index] == 'e')
	    {
	      result = index + 1;
	      break;
	    }
	  else
	    {
	      break;
	    }
	}
    }
  if (result == -1)
    {
      clear ();
    }
  return result;
};
