/*
 * Author:	gxcoo
 * Create date:	2004-03-06 16:03
 */

#ifndef _BLIST_H_
#define _BLIST_H_

#include <vector>
#include <string>
#include "bobject.h"


class CBList:public CBObject
{
public:
	CBList(void)
		:CBObject(3)
		{};
	~CBList(void)
	{
		clear();
	}

	typedef std::vector<CBObject*> CONTAINER;

private:
	CONTAINER m_value;
	void clear(void)
	{
		while(!m_value.empty())
		{
			CBObject* obj=m_value.back();
			m_value.pop_back();
			delete obj;
		}
	}
public:
	unsigned int getCount(void)
	{
		return m_value.size();
	};

	CBObject* getValue(unsigned int index)
	{
		if(m_value.size()>index)
		{
			return m_value[index];
		}
		else
		{
			return NULL;
		}
	};

	int parse(const char* buf,unsigned long bufLen);
	
	void get_bestr(std::string& str)
	{
		str+="l";
		for(size_t i=0;i<m_value.size();++i)
		{
			m_value[i]->get_bestr(str);
		}
		str+="e";
	};
};

#endif
